defmodule Auth.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  use Application

  def start(_type, _args) do
    children = [
      # Start the Ecto repository
      Auth.Repo,
      # Start the PubSub system
      {Phoenix.PubSub, name: Auth.PubSub}
      # Start a worker by calling: Auth.Worker.start_link(arg)
      # {Auth.Worker, arg}
    ]

    Supervisor.start_link(children, strategy: :one_for_one, name: Auth.Supervisor)
  end
end
